package gcaligner;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

// Class created by Simon Dellicour (April 2011).

public class InputFileReader 
{
	public ArrayList<String> lines; // this ArrayList has all the information coming from the input text file.
	public String inputName;
	public double maximumNumberOfDataRows;
	public double numberOfDataColumns;
	public double numberOfColumnsPerInjection;
	public double numberOfIndividuals;
	public ArrayList<Individual> individuals;
	public String individualsList;
	public String origins;

	public void readInput(String inputName) throws IOException 
		{
			BufferedReader in = new BufferedReader(new FileReader(inputName));
			String s1;
			ArrayList<String> lines0 = new ArrayList<String>();
			while ((s1 = in.readLine()) != null)
				lines0.add(s1);
			lines = lines0;
			maximumNumberOfDataRows = lines.size() - 2;
			in.close();
			
			individualsList = lines.get(0);
			origins = lines.get(1);
			String[] line2 = lines.get(3).split("	");
			numberOfDataColumns = line2.length;
			numberOfColumnsPerInjection = MainClass.numberOfColumnsPerInjection;
			numberOfIndividuals = numberOfDataColumns/numberOfColumnsPerInjection;
			
			individuals = new ArrayList<Individual>();
			for (int i = 0; i < (int) numberOfIndividuals; i++)
				{
					Individual individual = new Individual(i + 1);
					individuals.add(individual);
				}
	
			for (int i = 2; i < maximumNumberOfDataRows + 2; i++)
				{
					String s2 = new String();
					s2 = lines.get(i);
					String[] line = s2.split("	");
					for (int j = 0; j < numberOfIndividuals; j++)
						{
							if (j < (line.length/numberOfColumnsPerInjection))
								{
									int k = (int) (((j+1)*numberOfColumnsPerInjection) - numberOfColumnsPerInjection);
									String string = new String(); // string = line[k+0] + "	" + line[k+1]  + "	" + line[k+2];		
									for (int l = 0; l < (int) numberOfColumnsPerInjection; l++)
										{
											string = string + line[k+l];
											if (l < ((int) numberOfColumnsPerInjection - 1))
													{
														string = string + "	";
													}
										}	
									individuals.get(j).columns.add(string);
									individuals.get(j).retensionTimesString.add(line[k+0]);
								}
							else
								{
									String string = new String(); // "	" + "	" + "	";							
									for (int l = 0; l < (int) numberOfColumnsPerInjection; l++)
										{
											string = string + "	"; // System.out.println(l+1);
										}	
									individuals.get(j).columns.add(string);
									individuals.get(j).retensionTimesString.add("");
								}
						}
				}
		}
}
